#include <eo>
#include <iostream> 

#include <tcl.h>
#include <tk.h>

using namespace std;

#include "../strategy.h"
#include "../compete.h"
#include "../fitness.h"
#include "../ind_strategy.h"

// todo: get rid of global stuff
bool bstop;
bool bexit;
bool bnext; 
bool bprint;
bool bconfig; 
bool bbestindi; 
bool bset; 

// TODO  fuj -> jedna funkce a switch !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
int stop( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  //  printf("--------- STOP ----------- \n");
  bstop = true;
  return 0;
} 

int cont( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- CONTINUE ----------- \n");
  bstop = false;
  return 0;
} 

int exit( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  //  printf("--------- EXIT ----------- \n");
  bstop = false; 
  bexit = true;
  return 0;
} 

int next( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  // printf("--------- NEXT ----------- \n");
  bnext = true;
  return 0;
} 


int print( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  // printf("--------- PRINT ----------- \n");
  bprint = true;
  return 0;
} 

int config( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  bconfig = true;
  return 0;
} 


int bestindi(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bbestindi = true;
  return 0; 
} 

int cset(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bset = true;
  return 0; 
} 



class myGui : public eoContinue<Indi> {

public:

  myGui(double _from=0.0, double _to=1.0) : crossRate(dummy), mutRate(dummy) {  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = false; 
    Init(); 
  }; 

  myGui(double& _crossRate, double& _mutRate, 
	double _from=0.0, double _to=1.0) : crossRate(_crossRate), mutRate(_mutRate) {  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = true; 
    Init(); 
  }; 

  void setup(const vector<string>& _sNames, const vector<int>& _sCounts) {
    sNames = _sNames;
    sCounts = _sCounts; 
  
    // create window with stats
    int ret = Tcl_VarEval(interp,
			  "toplevel .populace \n",
			  0);
    if (ret != TCL_OK) printf(interp->result);
   
    
    for (unsigned i=0; i<sNames.size(); i++) {
      char number[10];
      sprintf(number,"%d",sCounts[i]);
         
      ret = Tcl_VarEval(interp,
			"set v",sNames[i].c_str()," ",number,"\n",
			"label .populace.n",sNames[i].c_str()," -text \"",sNames[i].c_str(),"\" \n",
			"entry .populace.e",sNames[i].c_str()," -textvariable v",sNames[i].c_str()," -width 4\n",
			"grid  .populace.n",sNames[i].c_str()," .populace.e",sNames[i].c_str()," -sticky ew -pady 2 -padx 1\n",
			0);
      if (ret != TCL_OK) printf(interp->result);
       
    } 
    
  } 

  


  void Init() {
    interp = Tcl_CreateInterp() ;
    Tcl_Init(interp);

    int ret;
    ret = Tk_Init(interp);
  
    if (ret != TCL_OK) {
      printf("Unable to initialize TK.\n");
      printf(interp->result);
    } 

    Tcl_CreateCommand( interp, "c_stop", stop, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_continue", cont, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_exit", exit, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_next", next, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print", print, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_config", config, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print_bestindi", bestindi, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_set", cset, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );

    ret = Tcl_EvalFile(interp, "gui/gui.txt");
  
    if (ret != TCL_OK) {
      printf("Error during initial script.\n");
      printf(interp->result); 
    }

    char strFrom[10]; snprintf(strFrom,9,"%lf",from);  
    char strTo[10]; snprintf(strTo,9,"%lf",to);  
    Tcl_SetVar(interp, "f", strFrom, 0); 
    Tcl_SetVar(interp, "t", strTo, 0); 
  } 

  /*
  void draw(double value) {

    const char *x = Tcl_GetVar(interp,"x",0);
    const char *y = Tcl_GetVar(interp,"y",0);
    const char *h = Tcl_GetVar(interp,"h",0);
    const char *f = Tcl_GetVar(interp,"f",0);
    const char *t = Tcl_GetVar(interp,"t",0);

    
    char x2[50];
    char xm[50];
    char y2[50];

    if (value < from) { value = from; printf("Warning: fitness out of range of graph.\n"); }
    if (value > to ) { value = to; printf("Warning: fitness out of range of graph.\n"); }

    sprintf(y2,"%lf",(atof(t)-value)*atof(h)/(atof(t)-atof(f)));
     
    //    printf( y2 );

    if (!strcmp(y,"start")) { // first call -  set initial value
      Tcl_SetVar(interp, "y", y2, 0);
      return; 
    } 

    // draw line
    sprintf(x2,"%i",atoi(x)+5);
    sprintf(xm,"%i",atoi(x)-5000); // ??? tune the constant

    char drawline[100]; 
    char deltag[100]; 
    char conf[100]; 
    
    snprintf(drawline,99, 
	     ".graph.c create line %s %s %s %s  -fill red -width 2 -tag x2\n",
	     x,y, 
	     x2,y2); 

    snprintf(deltag,99, 
	     ".graph.c delete tag x %s\n",
	     xm); 

    snprintf(conf,99,
	     ".graph.c configure -scrollregion { %s 0 %s %s }\n",
	     xm, x2, h); 


    //    printf("%s %s %s",drawline, deltag, conf);

    int ret = Tcl_VarEval(interp,
			  drawline,deltag, conf, 
			  ".graph.c xview moveto 1\n", 
			  0);

    if (ret != TCL_OK) {
      printf("Drawing to graph failed.\n");
      printf(interp->result);
    }

    Tcl_SetVar(interp, "x", x2, 0);
    Tcl_SetVar(interp, "y", y2, 0);
    } */

  
  void do_select(const vector<string>& names,vector<int>& numbers) { 
    wait4set = true; 
    select(names,numbers); 
    while (wait4set) {
      Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT);
      if (bset) 
	set(names,numbers);
    }
  }
  
  

  virtual bool operator()(const eoPop<Indi>& _pop) {
    
    //    
    // cout << iter << ": "<<  _pop.best_element().fitness() << endl;
    //

    Tcl_SetVar(interp, "Generace",strIter(),0);
    double bestFit = _pop.best_element().fitness();
    
    Tcl_SetVar(interp, "Fitnes",strFitness(bestFit),0); 

    //  if (crossRateValid) Tcl_SetVar(interp,"Cross",strDouble(crossRate),0);
    //if (mutRateValid) Tcl_SetVar(interp,"Mut",strDouble(mutRate),0);

    //  draw(bestFit); 

    //    if (bstop) { //  jen pokud krokuju
      // statistika populace
      for (unsigned i=0; i<sCounts.size(); i++) 
	sCounts[i] = 0;
      
      for (unsigned i=0; i<sNames.size(); i++) 
	for (unsigned j=0; j<_pop.size(); j++) 
	  if (_pop[j].myStrategy->getName() == sNames[i]) 
	    sCounts[i] ++; 
      
      // set vars
      for (unsigned i=0; i<sNames.size(); i++) {
	char value[10];
	sprintf(value,"%d",sCounts[i]);
	string name = "v"+sNames[i]; 
	Tcl_SetVar(interp,name.c_str(),value, 0); 
      }
      // }
    iter++;
    

    bnext = false; 
    while (bstop && !bnext) { 

      Tcl_DoOneEvent(TCL_ALL_EVENTS);
 
      if (bprint) {
	eoPop<Indi> myPop  = _pop;
	//	myPop.sort();
	cout << myPop;
	bprint = false; 
      } 
      
    }

    Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT);

    return !bexit;
  }

    
    int set(const vector<string>& names,vector<int>& numbers) {

      string value; 
      string name;

      for (unsigned i=0; i<names.size(); i++) { 
	// get value of checkbox 
	name = "v" + names[i]; 
	value = Tcl_GetVar(interp,name.c_str(),0);
	
	numbers[i] = atoi(value.c_str()); 
      } 
    
      int ret = Tcl_VarEval(interp,
			    "destroy .selekce",
			    0); 
      if (ret != TCL_OK) {
	printf(interp->result);
      }

      wait4set = false;
      return 0; 
    }
  
    int select(const vector<string>& names,vector<int>& numbers)  {

      printf("--------- select ----------- \n");
    
    int ret = Tcl_VarEval(interp,
			  "toplevel .selekce \n",
			  0);
    if (ret != TCL_OK) {
      printf(interp->result);
    } 


    for (unsigned i=0; i<names.size(); i++) {

      //      cout << i << ": " << names[i] << " " << numbers[i] << endl;
      
      char number[10];
      sprintf(number,"%d",numbers[i]);
      
      
      ret = Tcl_VarEval(interp,
			"set v",names[i].c_str()," ",number,"\n",
			"label .selekce.n",names[i].c_str()," -text \"",names[i].c_str(),"\" \n",
			"entry .selekce.e",names[i].c_str()," -textvariable v",names[i].c_str()," -width 4\n",
			"grid  .selekce.n",names[i].c_str()," .selekce.e",names[i].c_str()," -sticky ew -pady 2 -padx 1\n",
			0);
      if (ret != TCL_OK) {
	printf(interp->result);
	} 
    } 
    
    ret = Tcl_VarEval(interp,
		      "grid [button .selekce.exit -text \"Nastav\" -command { c_set }]\n",
		      0);

    if (ret != TCL_OK) {
      printf(interp->result);
    } 

  return 0; 
}
  
    
public:
  bool wait4set; 
  
private:
  Tcl_Interp *interp; 
  int iter; 
  
  double from, to; 

  char buf1[20]; // buffer for iter 
  char buf2[20]; // buffer for fitness  
  char buf3[20]; // buffer for fitness  

  const char *strIter() { snprintf(buf1,19,"%d",iter); return buf1; };
  const char *strFitness(double fitness) {  snprintf(buf2,19,"%lf",fitness); return buf2; }; 
  const char *strDouble(double x) {  snprintf(buf3,19,"%.2lf",x); return buf3; }; 

  double &crossRate;
  bool crossRateValid; 

  double &mutRate; 
  bool mutRateValid; 

  double dummy;


  Compete competition;

  vector<string> sNames;
  vector<int> sCounts; 
};



